showError = function (msg) {
    $("#changelog").html("");
    $("#updatecontent").html("An error has occured: " + msg + "<br><br><a class=\"ui button\" href=\"books.html\">Go back</a>");
}


download = function (url, dest, callback, errorcallback) {
    var oReq = new XMLHttpRequest();
    oReq.open("GET", url, true);
    oReq.responseType = "arraybuffer";

    oReq.onload = function (oEvent) {
        var arrayBuffer = oReq.response;
        if (arrayBuffer) {
            fs.appendFile(dest, new Buffer(arrayBuffer), function (err) {
                if (err) {
                    errorcallback(err);
                    return;
                }
                callback(dest);
            });
        }
    };

    oReq.send(null);
};

init = function () {
    isNewVersionAvailable().then(function (r) {
        try {
            request("GET", r.versionJSON.changelog).then(function (h) {
                $("#changelog").html(h);
                if (h.trim() == "" || h.status == 404) {
                    $("#changelog").html("Error getting changelog");
                }
            }, function (h) {
                if (h.status == 404) {
                    $("#changelog").html("Error getting changelog");
                }
            });
        } catch (e) {
            $("#changelog").html("Error getting changelog");
        }

        try {
            if (r.newVersion) {
                if (isPortable()) {
                    $("#updatecontent").html("You are using a portable version. Please go to <a href=\"javascript:nw.Shell.openExternal('" + r.versionJSON.download.windows.x64.webpage + "');\">the BookReader downloads page</a> and download the latest portable version and extract it over your current version.<br><br><a class=\"ui button\" href=\"books.html\">Go back</a>");
                } else {
                    if (nw.process.platform == "linux") {
                        $("#updatecontent").html("You are using the Linux version. Please go to <a href=\"javascript:nw.Shell.openExternal('" + r.versionJSON.download.linux.x64.webpage + "');\">the BookReader downloads page</a> and download the latest Linux version and extract it over your current version.<br><br><a class=\"ui button\" href=\"books.html\">Go back</a>");
                    } else {
                        if (nw.process.platform.startsWith("win")) {
                            $("#updatecontent").html('<div class="ui active inline loader"></div><div class="label">Downloading Update. This may take 5 - 10 minutes</div>');
                            var dlexe = os.tmpDir() + "/BookReaderUpdate" + String(new Date().getTime()) + ".exe";
                            console.log(r.versionJSON.download.windows.x64.installer);
                            download(r.versionJSON.download.windows.x64.installer, dlexe, function (f) {
                                try {
                                    $("#updatecontent").html('<div class="ui progress" id="dlprogress"><div class="bar"><div class="progress"></div></div><div class="label">Updating</div></div>');
                                    require("child_process").spawn(f, ["/SP-", "/silent"], {
                                        detached: true
                                    }).unref();
                                } catch (e) {
                                    showError("Error installing update. Try installing it manually from <a href=\"javascript:nw.Shell.openExternal('" + r.versionJSON.download.windows.x64.webpage + "');\">the BookReader webpage</a>.");
                                }
                            }, function (err) {
                                console.log(err);
                                showError("Error downloading update: " + err.message + ". Try installing it manually from <a href=\"javascript:nw.Shell.openExternal('" + r.versionJSON.download.windows.x64.webpage + "');\">the BookReader webpage</a>.");
                            });
                        }
                    }
                }
            } else {
                $("#updatecontent").html("No updates available. <br><br><a class=\"ui button\" href=\"books.html\">Go back</a>")
            }
        } catch (e) {
            showError("Error loading update information: " + e.message);
        }
    }, function (e) {
        showError(e.message);
    });
}

init();