getSettingsElements = function() {
    return {
        family: $("#family"),
        size: $("#size"),
        colorscheme: $("#colorscheme"),
        lineheight: $("#lineheight"),
        margin: $("#margin")
    };
}

loadSettings = function() {
    var sel = getSettingsElements();
    getSetting("family").then(function(val) {
        sel.family.val(val).change();
    });

    getSetting("size").then(function(val) {
        sel.size.val(val).change();
    });

    getSetting("colorscheme").then(function(val) {
        sel.colorscheme.val(val).change();
    });

    getSetting("lineheight").then(function(val) {
        sel.lineheight.val(val).change();
    });

    getSetting("margin").then(function(val) {
        sel.margin.val(val).change();
    });

    updateSettings();
}

updateSettings = function() {
    var sel = getSettingsElements();
    console.log("Updating settings");
    setSetting("family", sel.family.val());
    setSetting("size", sel.size.val());
    setSetting("colorscheme", sel.colorscheme.val());
    setSetting("lineheight", sel.lineheight.val());
    setSetting("margin", sel.margin.val());
    getSettingsCSS(true).then(function(css) {
        $("#settingspreview").attr("style", css);
    });
}

styleDropdowns = function() {
    var css = "";
    $("select#family option").each(function(k, v) {
        css += ".item[data-value=\"" + $(v).attr("value") + "\"]{font-family: " + $(v).attr("value") + " !important;}"
    });
    $("select#size option").each(function(k, v) {
        css += ".item[data-value=\"" + $(v).attr("value") + "\"]{font-size: " + $(v).attr("value") + " !important;}"
    });
    $("select#lineheight option").each(function(k, v) {
        css += ".item[data-value=\"" + $(v).attr("value") + "\"]{line-height: " + $(v).attr("value") + " !important;}"
    });
    $.each(colorSchemes, function(k, v) {
        css += ".item[data-value=\"" + k + "\"]{background: " + v.bg + " !important;color: " + v.fg + " !important;}"
    });
    $('body').append('<style>' + css + "</style>");
}

init = function() {
    loadSettings();
    $('select').dropdown();
    styleDropdowns();
    try {
        var packagejson = getOwnPackageJSON();
        console.log(packagejson);
        $("#productname").text(packagejson.name);
        $("#versioninfo").html([
          "Version: " + String(packagejson.version),
          packagejson.copyright,
          "<div class=\"ui basic buttons\"><a target=\"_blank\" class=\"ui basic button\" href=\"" + packagejson.homepage + "\">" + packagejson.name + " webpage</a><a target=\"_blank\" href=\"" + packagejson.bugs + "\" class=\" ui basic button\">Bug Reports</a><a target=\"_blank\" href=\"http://github.com/" + packagejson.repository + "\" class=\" ui basic button\">Source Code</a></div>"
        ].join("<br>"));
    } catch (e) {
        console.error(e)
    }
}
init();
