bookfilename = null;
cachedbookmeta = null;

init = function() {
    if (localStorage.getItem("bookreader.global.lastread.filename") == null) {
        $("#bookstats").html("Not currently reading any book.")
    } else {
        try {
            bookfilename = localStorage.getItem("bookreader.global.lastread.filename");
            if (bookfilename.startsWith("file://")) {
                if (!fsExists(bookfilename.replace("file://", ""))) {
                    throw {
                        message: "File not found"
                    };
                }
            }

            if (bookfilename == "" || bookfilename == null || bookfilename == undefined) {
                throw {
                    message: "File not found"
                };
            }

            getBookMetadata(bookfilename.replace("file://", ""), true).then(function(meta) {
                cachedbookmeta = meta;
                document.title = meta.title + " - " + meta.author;

                $("#title").text(meta.title);
                $("#author").text(meta.author);
                $("#percent").text((String(parseFloat(localStorage.getItem("bookreader.book." + meta.bookid + ".curpercent")).toFixed(2) || 0)) + "%");
                $("#minutes").text((String((parseFloat(localStorage.getItem("bookreader.book." + meta.bookid + ".secsread") || 0) / 60).toFixed(0))));
                $("#bookmarks").text(String((localStorage.getItem("bookreader.book." + meta.bookid + ".bookmarks") || "").split("|").filter(Boolean).length));
                $("#cover").attr("src", meta.coverurl);

                $("#open").attr("href", "reader.html?bookurl=" + btoa(bookfilename));
                $("#details").attr("href", "details.html?bookurl=" + btoa(bookfilename));
            });
        } catch (e) {
            $("#bookstats").html("Not currently reading any book.")
        }
    }

    $("#bookcount").text(getBookFilenames().length);
    $("#totalminutes").text((String((parseFloat(localStorage.getItem("bookreader.globalstats.secsread") || 0) / 60).toFixed(0))));
}
init()
